#ifndef INTERVAL_CMATH_H
#define INTERVAL_CMATH_H

#include "interval.h"

namespace std2 {

template<class T> interval<T> acos(const interval<T>&);
template<class T> interval<T> asin(const interval<T>&);
template<class T> interval<T> atan(const interval<T>&);
template<class T> interval<T> cos(const interval<T>&);
template<class T> interval<T> cosh(const interval<T>&);
template<class T> interval<T> exp(const interval<T>&);
template<class T> interval<T> log(const interval<T>&);
template<class T> interval<T> log10(const interval<T>&);
template<class T> interval<T> pow(const interval<T>&, int);
template<class T> interval<T> pow(const interval<T>&, const T&);
template<class T> interval<T> pow(const interval<T>&, const interval<T>&);
template<class T> interval<T> pow(const T&, const interval<T>&);
template<class T> interval<T> sin(const interval<T>&);
template<class T> interval<T> sinh(const interval<T>&);
template<class T> interval<T> tan(const interval<T>&);
template<class T> interval<T> tanh(const interval<T>&);

template<> interval<float> acos(const interval<float>&);
template<> interval<float> asin(const interval<float>&);
template<> interval<float> atan(const interval<float>&);
template<> interval<float> cos(const interval<float>&);
template<> interval<float> cosh(const interval<float>&);
template<> interval<float> exp(const interval<float>&);
template<> interval<float> log(const interval<float>&);
template<> interval<float> log10(const interval<float>&);
template<> interval<float> pow(const interval<float>&, int);
template<> interval<float> pow(const interval<float>&, const float&);
template<> interval<float> pow(const interval<float>&, const interval<float>&);
template<> interval<float> pow(const float&, const interval<float>&);
template<> interval<float> sin(const interval<float>&);
template<> interval<float> sinh(const interval<float>&);
template<> interval<float> tan(const interval<float>&);
template<> interval<float> tanh(const interval<float>&);

template<> interval<double> acos(const interval<double>&);
template<> interval<double> asin(const interval<double>&);
template<> interval<double> atan(const interval<double>&);
template<> interval<double> cos(const interval<double>&);
template<> interval<double> cosh(const interval<double>&);
template<> interval<double> exp(const interval<double>&);
template<> interval<double> log(const interval<double>&);
template<> interval<double> log10(const interval<double>&);
template<> interval<double> pow(const interval<double>&, int);
template<> interval<double> pow(const interval<double>&, const double&);
template<> interval<double> pow(const interval<double>&, const interval<double>&);
template<> interval<double> pow(const double&, const interval<double>&);
template<> interval<double> sin(const interval<double>&);
template<> interval<double> sinh(const interval<double>&);
template<> interval<double> tan(const interval<double>&);
template<> interval<double> tanh(const interval<double>&);

template<> interval<long double> acos(const interval<long double>&);
template<> interval<long double> asin(const interval<long double>&);
template<> interval<long double> atan(const interval<long double>&);
template<> interval<long double> cos(const interval<long double>&);
template<> interval<long double> cosh(const interval<long double>&);
template<> interval<long double> exp(const interval<long double>&);
template<> interval<long double> log(const interval<long double>&);
template<> interval<long double> log10(const interval<long double>&);
template<> interval<long double> pow(const interval<long double>&, int);
template<> interval<long double> pow(const interval<long double>&, const long double&);
template<> interval<long double> pow(const interval<long double>&, const interval<long double>&);
template<> interval<long double> pow(const long double&, const interval<long double>&);
template<> interval<long double> sin(const interval<long double>&);
template<> interval<long double> sinh(const interval<long double>&);
template<> interval<long double> tan(const interval<long double>&);
template<> interval<long double> tanh(const interval<long double>&);

} // namespace std2

#endif // INTERVAL_CMATH_H
